/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the OkResult type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &OkResult{}

// OkResult struct for OkResult
type OkResult struct {
	StatusCode *int32 `json:"statusCode,omitempty"`
}

// NewOkResult instantiates a new OkResult object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewOkResult() *OkResult {
	this := OkResult{}
	return &this
}

// NewOkResultWithDefaults instantiates a new OkResult object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewOkResultWithDefaults() *OkResult {
	this := OkResult{}
	return &this
}

// GetStatusCode returns the StatusCode field value if set, zero value otherwise.
func (o *OkResult) GetStatusCode() int32 {
	if o == nil || IsNil(o.StatusCode) {
		var ret int32
		return ret
	}
	return *o.StatusCode
}

// GetStatusCodeOk returns a tuple with the StatusCode field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OkResult) GetStatusCodeOk() (*int32, bool) {
	if o == nil || IsNil(o.StatusCode) {
		return nil, false
	}
	return o.StatusCode, true
}

// HasStatusCode returns a boolean if a field has been set.
func (o *OkResult) HasStatusCode() bool {
	if o != nil && !IsNil(o.StatusCode) {
		return true
	}

	return false
}

// SetStatusCode gets a reference to the given int32 and assigns it to the StatusCode field.
func (o *OkResult) SetStatusCode(v int32) {
	o.StatusCode = &v
}

func (o OkResult) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o OkResult) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.StatusCode) {
		toSerialize["statusCode"] = o.StatusCode
	}
	return toSerialize, nil
}

type NullableOkResult struct {
	value *OkResult
	isSet bool
}

func (v NullableOkResult) Get() *OkResult {
	return v.value
}

func (v *NullableOkResult) Set(val *OkResult) {
	v.value = val
	v.isSet = true
}

func (v NullableOkResult) IsSet() bool {
	return v.isSet
}

func (v *NullableOkResult) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableOkResult(val *OkResult) *NullableOkResult {
	return &NullableOkResult{value: val, isSet: true}
}

func (v NullableOkResult) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableOkResult) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
